c----------------------------------------
c Fortran Program for Packege BIDO
c (C) 2009 I. Cho All Rights Reserved.
c----------------------------------------
#include "PARAM.h"
      external anoise,anoisefix,aj0,rkmin4nsr,rkmin4nsr2
      real Fdush
      common/OBSERVED/coh2,spr,bsj0,nseis
      common/OBSERVED2/ansr,err0
      common/IDS/iddltmax
      data re,ae/1.e-7,1.e-7/
      character*15 ceps_max,ceps_min
c
      read(5,*)radius,nseis
 10   read(5,*,err=99,end=99)freq,coh2,dum1,spr,dum2,sprnew2
      if(freq.ne.dum1.or.freq.ne.dum2)then
         write(6,*)'ERROR: inconcistent frequency !',freq,dum1,dum2
         stop
      endif

c-----------------------------
      iddltmax=0
      b=0.
      c=100.
      r=c
      call fzero(anoise, b, c, r, re, ae, iflag0)
      eps_max=b

c-----------------------------
      iddltmax=1
      b=0.
      c=100.
      r=c
      call fzero(anoise, b, c, r, re, ae, iflag1)
      eps_min=b
      call caldltmx(dltmax,eps_min)

c-----------------------------
      if(iflag0.eq.1)then
         write(ceps_max,'(e15.7)')eps_max
      else
         write(ceps_max,'(a15)')'    NO ROOT    ' 
      endif
      if(iflag1.eq.1)then
         write(ceps_min,'(e15.7)')eps_min
      else
c         write(ceps_min,'(a15)')'    NO ROOT    ' 
         write(ceps_min,'(a15)') '    1234567    ' 
      endif

      write(6,'(e15.7,2a15,e15.7)')freq,ceps_max,ceps_min,dltmax

c      if(iflag0.eq.1)then
c----------------------------------------
c added on 2010/10/21$B!!8B3&(BNS$BHf"*8B3&0LAjB.EY$KJQ49(B
c
c $B%N%$%:$K$h$k%9%Z%/%H%kHf$NDc8:N(ogCM$r(B
c err0=gn(rk_c)/g(rk_c)$B!!(B (1)
c $B$HDj5A$9$k!#$?$@$7!"(Brk_c$B$OBP1~$9$k8B3&(Brk($BH>7B!_GH?t(B)$B$G$"$k!#$^$?!"(B
c gn(rk)=[J0^2(rk)-nsr/nseis]/[J1^2(rk)-nsr/nseis] (2)
c g(rk)=J0^2(rk)/J1^2(rk) (3)
c (1),(2),(3)$B$h$j(B
c nsr(f)=[(1-err0)*nseis*J0^2(rk_c)J1^2(rk_c)]/[err0*(J0^2(rk_c)-J1^2(rk_c))]
c       ...(4)
c (4)$B$r8B3&(Brk$B!!(Brk_c$B$K$D$$$F?tCME*$K2r$-!"<!<0$G8B3&0LAjB.EY$r7W;;$9$k!#(B
c phasevel_c=2$B&P(Bfr/rk_c
c----------------------------------------
c         b=0.001
c         c=2.
c         r=c
c         ansr=eps_max
c         err0=0.7   ! $B%9%Z%/%H%kHf$NDc8:N(ogCM(B
c         call fzero(rkmin4nsr, b, c, r, re, ae, iflag)
c         rkmin=b
c         alphamax=PI2/rkmin
c         pvmax=radius*freq*alphamax
c         if(iflag.eq.1)
c     +        write(7,'(4e15.7)')freq,pvmax,alphamax,rkmin
c      endif

      if(iflag0.eq.1)then
c----------------------------------------
c added on 2010/10/23$B!!8B3&(BNS$BHf"*8B3&0LAjB.EY$KJQ49(B
c
c $B%N%$%:$K$h$k0LAjB.EY$NDc8:N(ogCM(Berr0$B$H$9$k$H!"(B
c J0^2(rk_c/err0)/J1^2(rk_c/err0)
c$B!!!!!!!!!!!!(B=[J0^2(rk_c)+nsr/nseis]/[J1^2(rk_c)+nsr/nseis]. 
c $B$?$@$7!"(Bk_c$B$OBP1~$9$k8B3&GH?t(B(=2$B&P(Bf/phasevel_c)$B$G$"$k!#(B
c $B>e<0$r8B3&(Brk_c$B$K$D$$$F?tCME*$K2r$-!"<!<0$G8B3&0LAjB.EY$r7W;;$9$k!#(B
c 
c----------------------------------------
         b=0.001
         c=2.  ! 2.4$B$K$9$k$H2r$,5a$^$j$K$/$$!#(B
         r=c
         ansr=eps_max
         err0=0.9               ! $B0LAjB.EY$NDc8:N(ogCM(B
         call fzero(rkmin4nsr2, b, c, r, re, ae, iflag)
         rkmin=b
         alphamax=PI2/rkmin
         pvmax=radius*freq*alphamax
         if(iflag.eq.1)
     +        write(7,'(4e15.7)')freq,pvmax,alphamax,rkmin
      endif


      goto 10
 99   continue
      stop
      end
      
      subroutine cal_bsl(fjisu,x,y)
      parameter(ny=1)
      complex cy0,cy1,cy, z
      dimension cy0(ny),cy1(ny),cy(2)
      kode=2
      z=cmplx(x,0.)
      call cbesj(z, fjisu,  kode, ny, cy0, nz, ierr)
      if(nz.ne.0 .or. ierr.ne.0)then
         write(6,*)'Error:nz or ierr in cbesj()',nz,ierr
         stop
      endif
      y=cy0(1)*1.0
      return
      end

      function aj0(x)
      common/OBSERVED/coh2,spr,bsj0,nseis
      call cal_bsl(0.,x,y)
      aj0=y-bsj0
      return
      end

      function fdash(x)
      eps=1.e-2
      x0=x-eps
      x1=x+eps
      call cal_bsl(0.,x0,y0)
      call cal_bsl(0.,x1,y1)
      fdash=(y1-y0)/(2*eps)
      return
      end

c      function Fdash(x)
cc $B"_(BJ0(x)/$B"_(Bx
c      eps=1.e-4
c      x0=x-eps
c      x1=x+eps
c      call cal_bsl(0.,x0,y0)
c      call cal_bsl(0.,x1,y1)
c      Fdash=(y1-y0)/(2*eps)
c      return
c      end
      

      function anoise_org(eps)
      common/OBSERVED/coh2,spr,bsj0,nseis
c SPR=J0/(1+$B&E(B)                  
c i.e., J0=SPR(1+$B&E(B)                  --(0)
c coh2=J0^2 / [J0^2+$B&E(B/3][1+$B&E(B]       --(1)
      bsj0=spr*(1.+eps)
      bsj0sq=bsj0*bsj0
c----------------------------------------------------
c => $B4V0c$$(B $B=$@5(B 2005/8/23
c      anoise=coh2-bsj0sq/((bsj0sq+eps)*(1+eps/3))
      anoise=coh2-bsj0sq/((bsj0sq+eps/float(nseis))*(1.+eps))
c----------------------------------------------------
      return
      end

      function anoise(eps)
      common/OBSERVED/coh2,spr,bsj0,nseis
      common/IDS/iddltmax
      epsiron=1.e-8
c SPR=J0/(1+$B&E(B)                  
c i.e., J0=SPR(1+$B&E(B)                  --(0)
c coh2=J0^2 / [J0^2+$B&$(B+$B&E(B/3][1+$B&E(B]       --(1)
      bsj0=spr*(1.+eps)
      bsj0sq=bsj0*bsj0
c
      if(iddltmax.eq.0)then
         dltmax=0.
      else
c  case 1 (2$B%b!<%I$N>l9g$K$*$1$k(B-0.4<=J_i<=1$B$NMW@A$+$i(B)
         r1=1.-bsj0
         r2=bsj0+0.4
         if(r2.lt.r1)r1=r2
         dltmax=r1**2
c
c  case 2 $B&E!a(B0 ($B$3$3$G$O&E$N:G>.CM$r9M$($k$?$a%T!<%/CM$r9MN8$9$kI,MW$O$J$7(B)
         dltmax1=spr**2*(1./coh2-1)-epsiron
         if(dltmax1.le.dltmax)dltmax=dltmax1
c
      endif
c
      anoise=coh2-bsj0sq/((bsj0sq+dltmax+eps/float(nseis))*(1.+eps))
      return
      end

      function rkmin4nsr(rk)
      common/OBSERVED/coh2,spr,bsj0,nseis
      common/OBSERVED2/ansr,err0
      call cal_bsl(0.,rk,y0)
      call cal_bsl(1.,rk,y1)
      y0sq=y0**2
      y1sq=y1**2
      rkmin4nsr=ansr-
     +     (nseis*y0sq*y1sq-err0*nseis*y0sq*y1sq)/(err0*y0sq-y1sq)
      return
      end

      function rkmin4nsr2(rk)
      common/OBSERVED/coh2,spr,bsj0,nseis
      common/OBSERVED2/ansr,err0
      rke=rk/err0
      eps=ansr/float(nseis)
      call cal_bsl(0.,rk,y0)
      call cal_bsl(1.,rk,y1)
      call cal_bsl(0.,rke,y0e)
      call cal_bsl(1.,rke,y1e)
      y0sq=y0**2
      y1sq=y1**2
      y0esq=y0e**2
      y1esq=y1e**2
      rkmin4nsr2=y0esq/y1esq-(y0sq+eps)/(y1sq+eps)
      return
      end

      function anoisefix(eps)
      common/OBSERVED/coh2,spr,bsj0,nseis
      bsj0sq=bsj0*bsj0
c      anoise=coh2-bsj0sq/((bsj0sq+eps)*(1+eps/3))
c => $B4V0c$$(B $B=$@5(B 2005/8/23
      anoise=coh2-bsj0sq/((bsj0sq+eps/float(nseis))*(1.+eps))
      return
      end

      subroutine caldltmx(dltmax,eps)
      common/OBSERVED/coh2,spr,bsj0,nseis
      epsiron=1.e-8
      dltmax=1.e18
c     case 1 (2$B%b!<%I$N>l9g$K$*$1$k(B-0.4<=J_i<=1$B$NMW@A$+$i(B)
      bsj0=spr*(1.+eps)
      r1=1.-bsj0
      r2=bsj0+0.4
      if(r2.lt.r1)r1=r2
      dltmax1=r1**2
      if(dltmax1.le.dltmax)dltmax=dltmax1
c     case 2 
      eps_p=0.5/coh2 - 0.5/(float(nseis)*spr**2)- 1. 
      if(eps_p.gt.0.)then
c  $B%T!<%/CM(B
         dltmax1=(spr**2./coh2 - 2.*spr**2. - 1./float(nseis))**2.
     +        + 4.*spr**4.*(1./coh2-1.)
         dltmax1=dltmax1/(4.*spr**2.)
      else
c  $B&E!a(B0
         dltmax1=spr**2.*(1./coh2-1.)-epsiron
      endif
      if(dltmax1.le.dltmax)dltmax=dltmax1
      return
      end
